[Setting category="General" name="Scale the highest shadow group by:" min="1" max="8" description="You can still set this higher by using crtl + click, but it probably won't give better results"]
float Setting_HighestShadowDistanceScale = 1.0;

// Apply the scale value
void ApplySettings(float distanceScale) {
    CHmsConfig@ config = GetApp().Viewport.Config;
    uint maxShadowGroupIndex = 0;
    for (uint i = 0; i < config.ShadowGroups.Length; i++) {
        if (config.ShadowGroups[i].TexelCountX > config.ShadowGroups[maxShadowGroupIndex].TexelCountX) maxShadowGroupIndex = i;
    }
    CHmsShadowGroup@ maxShadowGroup = config.ShadowGroups[maxShadowGroupIndex];
    if (maxShadowGroup is null) {
        error("Max shadow group handle is null!");
        return;
    }
    maxShadowGroup.PssmDistScale = distanceScale;
}

// Reset the scale value to default
void Reset() {
    ApplySettings(1.0);
}

void OnSettingsChanged() {
    ApplySettings(Setting_HighestShadowDistanceScale);
}

void OnDestroyed() {
    Reset();
}

void OnDisabled() {
    Reset();
}

void ApplyLoop() {
    while (true) {
        ApplySettings(Setting_HighestShadowDistanceScale);
        sleep(1000);
    }
}

void Main() {
    startnew(ApplyLoop);
}